# Rozeta

## About

**Rozeta** is a program that plots **rose diagrams**.

A rose diagram is a circular histogram that shows the distribution of linear elements on a plane. It can be, for example, the distribution of transport directions in a sedimentation basin, inclinations of fracture planes, paleocurrent directions, wind directions, etc.

Rose diagrams are often used in structural geology, geography and other sciences.

![The main window](doc_images/main_window.png)

## Program description

[Rozeta_description_EN.md - English](Rozeta_description_EN.md)  
[Rozeta_description_PL.md - Polish](Rozeta_description_PL.md)

## License and download

The program is completely free (**public domain**) and you can use it without any restrictions, also for commercial purposes.

Program home page (with compiled binaries): [https://www.pazera-software.com/products/rozeta/](https://www.pazera-software.com/products/rozeta/)  
Source code: [https://github.com/jackdp/Rozeta](https://github.com/jackdp/Rozeta)  
Support for the author: [https://www.pazera-software.com/donation/](https://www.pazera-software.com/donation/)

## Development environment and compiler

[Lazarus IDE](https://www.lazarus-ide.org/) 2.2.2  
[Free Pascal compiler](https://www.freepascal.org/) 3.2.2

Installed via [fpcupdeluxe](https://github.com/LongDirtyAnimAlf/fpcupdeluxe).

In the Lazarus IDE install *Online Package Manager* (**OPM**).

Documentation (MD files) created with [VNote](https://github.com/vnotex/vnote).

## Libraries and components needed to compile the program

* [JPLib](https://github.com/jackdp/JPLib)
* [JPPack](https://github.com/jackdp/JPPack)
* [JPLaz](https://github.com/jackdp/JPModLib#jplaz)
* [IGDIPlusMod](https://github.com/jackdp/IGDIPlusMod)
* [GDIPlus-Library-for-Delphi-and-Lazarus](https://github.com/jackdp/GDIPlus-Library-for-Delphi-and-Lazarus)
* [VirtualTreeView V5](https://wiki.freepascal.org/VirtualTreeview) installed via OPM
* [ATFlatControls](https://github.com/Alexey-T/ATFlatControls) installed via OPM
* [JvclLaz](https://wiki.freepascal.org/JVCL_Components) installed via OPM
* [HtmlViewer](https://github.com/BerndGabriel/HtmlViewer) installed via OPM
* [DzHTMLText2](https://github.com/jackdp/DzHTMLText2)

## Icons

Icons courtesy of Axialis Software [https://www.axialis.com/](https://www.axialis.com/)  
Icons generated by [Axialis Icon Generator](https://www.axialis.com/download/ig.html) at native size (scale 1x).  
License: [Free License with Attribution (CC BY-ND 4.0)](https://www.axialis.com/icongenerator/iconset-license.html#free)
